/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.widget;

import android.appwidget.AppWidgetManager;
import android.content.Context;

import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.tool.ResourceParser;

// 定义一个具体的NoteWidgetProvider_4x类，继承自NoteWidgetProvider
public class NoteWidgetProvider_4x extends NoteWidgetProvider {
    // 当小部件需要更新时调用
    @Override
    public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
        // 调用父类的update方法进行更新
        super.update(context, appWidgetManager, appWidgetIds);
    }

    // 获取小部件的布局资源ID
    @Override
    protected int getLayoutId() {
        // 返回4x小部件的布局资源ID
        return R.layout.widget_4x;
    }

    // 获取小部件的背景资源ID
    @Override
    protected int getBgResourceId(int bgId) {
        // 根据传入的背景ID，返回对应的4x小部件背景资源ID
        return ResourceParser.WidgetBgResources.getWidget4xBgResource(bgId);
    }

    // 获取小部件的类型
    @Override
    protected int getWidgetType() {
        // 返回小部件的类型，这里是4x类型的笔记小部件
        return Notes.TYPE_WIDGET_4X;
    }
}